#!python2
#coding:utf-8

import fire 
import  mdtraj as md 
import numpy as np
import scipy
import scipy.cluster.hierarchy 
import time
from functools import wraps
from pprint import pprint
from scipy.cluster.vq import vq,kmeans,whiten
import os
from glob import glob
def fn_timer(function):
    @wraps(function)
    def function_timer(*args, **kwargs):
        t0 = time.time()
        result = function(*args, **kwargs)
        t1 = time.time()
        print ("Total time running %s: %s seconds" %
            (function.func_name, str(t1-t0))
            )
        return result
    return function_timer


@fn_timer
def get_cluster_hierachical(traj):
    '''
    '''
    print "number of frames in traj",traj.n_frames
    distances = np.empty((traj.n_frames, traj.n_frames))
    for i in range(traj.n_frames):
        distances[i] = md.rmsd(traj, traj, i)
    
    linkage = scipy.cluster.hierarchy.linkage(distances, method='average')
    # cluster = scipy.cluster.hierarchy.fcluster(Z=linkage, t=1, criterion='inconsistent')    
    cluster = scipy.cluster.hierarchy.fcluster(Z=linkage, t=100, criterion='maxclust')
    num=len(set(cluster))
    print "num of clusters:",num
    clu_result=[] 
    for i in range(num):
        li=np.where(cluster == i)[0]
        clu_result.append(li)
    return clu_result


@fn_timer 
def get_cluster_vq(traj):
    '''
    '''
    print "number of frames in traj",traj.n_frames
    distances = np.empty((traj.n_frames, traj.n_frames))
    for i in range(traj.n_frames):
        distances[i] = md.rmsd(traj, traj, i)
    data=whiten(distances)
    centroid=kmeans(data,100)[0]  
    pprint(centroid)
import os, tarfile
 
#一次性打包整个根目录。空子目录会被打包。
#如果只打包不压缩，将"w:gz"参数改为"w:"或"w"即可。
def make_targz(output_filename, source_dir):
    with tarfile.open(output_filename, "w:gz") as tar:
        tar.add(source_dir, arcname=os.path.basename(source_dir))
 
#逐个添加文件打包，未打包空子目录。可过滤文件。
#如果只打包不压缩，将"w:gz"参数改为"w:"或"w"即可。
def make_targz_one_by_one(output_filename, source_dir): 
    tar = tarfile.open(output_filename,"w:gz")
    for root,dir,files in os.walk(source_dir):
        for file in files:
            pathfile = os.path.join(root, file)
            tar.add(pathfile)
    tar.close()

def main(crdfile,topfile):
    '''
    usage:
        usage1 for amber trajectory: python  read_traj.py    xxxx.mdcrd  xxxx.prmtop
        usage2 for gromacs trajectory:
    '''
    #read traj
    traj=md.load(crdfile,top=topfile)
    #align all to the first frame
    print "start to superpose"
    traj.superpose(traj)
    total=traj.n_frames
    # traj=traj[0:1000]
    #get cluster_num_size  hierachical 层次聚类
    print "start to cluster"
    clu_result=get_cluster_hierachical(traj)
    print "finish cluster"
    outrajid=[]
    size_li=[]
    pprint(clu_result)
    for clu in clu_result:
        '''

        '''
        if 0 in clu:
            outrajid.append(0)
            size_li.append(len(clu))
        elif len(clu)/float(total)>0.01:
            '''
            '''
            outrajid.append(clu[0])
            size_li.append(len(clu))

    if 0 not in outrajid:
       traj[0].save("output_clu_0_.pdb")    

    fw=open("clu_size.txt",'w')
    fw.write("index:\n")
    fw.write(' '.join(map(str,outrajid)))
    fw.write("\nsize:\n")
    fw.write(' '.join(map(str,size_li)))
    fw.close()
    print "check ids:"
#    pprint(outrajid)
#    newtraj=traj[outrajid[0]]
    inde=0
    for id in outrajid:
        outfile="output_clu_"+str(id)+"_"+str(size_li[inde])+".pdb"
        traj[id].save(outfile)
        inde+=1
#    outfile="output_clu_0.pdb"
#    traj[0].save(outfile)
   # newtraj.save("output_clu.pdb")  

    
    

    # os.remove(topfile)
    # os.remove(crdfile)
    os.mkdir("result")

    outpdbs = glob("output_clu_*.pdb")
    for i in outpdbs:
        os.rename(i,'./result/%s'%i)
    os.rename('clu_size.txt','./result/clu_size.txt')
    make_targz_one_by_one('result.tar.gz','./result')        

    
    #select the represent conformation

    #矢量量化(scipy.cluster.vq):支持vector quantization 和 k-means 聚类方法 
    # clu_result2=get_cluster_vq(traj)








if __name__=="__main__":
    fire.Fire(main)


#并行聚类
#根据聚类情况输出聚类结果
#并行计算口袋



